package data;
import java.lang.*;
import java.util.ArrayList;

//--------------------------------------------------------------------//
/**
 * int ^nbV}bv
 */
public class IntegerMap extends AbstractNumberMap{

/** Gg[i[z */
  protected Entry table[];

/** eʊg臒l */
  protected int threshold;

/** ׌W */
  protected float loadFactor;

/** }bv̍\ύXꂽ */
  protected int modCount;

/**
 * ftHg̏eʂƕ׌Wŋ̃}bv\z
 */
  public IntegerMap(){
    this(DEFAULT_INITIAL_CAPACITY,DEFAULT_LOAD_FACTOR);
  }

/**
 * w肳ꂽeʂƕ׌Wŋ̃}bv\z
 * @param initialCapacity e
 * @param loadFactor ׌W
 */
  public IntegerMap(int initialCapacity,float loadFactor){
    super();
    if(initialCapacity<0){
      throw new IllegalArgumentException
      	("Illegal initial capacity: "+initialCapacity);
    }
    if(loadFactor<=0f || Float.isNaN(loadFactor)){
      throw new IllegalArgumentException
      	("Illegal load factor: "+loadFactor);
    }
    initialCapacity=Math.min(initialCapacity,MAXIMUM_CAPACITY);

    int capacity=1;
    while(capacity<initialCapacity) capacity<<=1;

    this.loadFactor=loadFactor;
    threshold=(int)(capacity*loadFactor);
    table=new Entry[capacity];
    modCount=0;
  }

//--------------------------------------------------------------------//
/**
 * ߂邽߃nbVlԂ
 * @param x nbVlvZl
 * @return nbVl
 */
  protected static int hash(int x){
    int h=x;
    h+=~(h<<9);
    h^= (h>>>14);
    h+= (h<<4);
    h^= (h>>>10);
    return h;
  }

//--------------------------------------------------------------------//
/**
 * nbVlɑΉz̃CfbNXԂ
 * @param h nbVl
 * @param length z̑傫
 * @return nbVlɑΉz̃CfbNX
 */
  protected static int index(int h,int length){
    return (h&(length-1));
  }

//--------------------------------------------------------------------//
/**
 * Gg[ǉ
 * @param hash nbVl
 * @param key L[
 * @param value L[ɑΉl
 * @param index Gg[ǉCfbNX
 */
  protected void addEntry(int hash,int key,int value,int index){
    table[index]=new Entry(hash,key,value,table[index]);
    size++;
    if(size>=threshold) resize(table.length<<1);
  }

//--------------------------------------------------------------------//
/**
 * eʂύX
 * @param newCapacity Ve
 */
  protected void resize(int newCapacity){
    Entry oldTable[]=table;
    int oldCapacity=oldTable.length;
    if(size<threshold || oldCapacity>=newCapacity) return;

    Entry newTable[]=new Entry[newCapacity];
    for(int i=0;i<oldCapacity;i++){
      Entry e=oldTable[i];
      if(e!=null){
      	oldTable[i]=null;
      	do{
      	  Entry next=e.next;
      	  int index=index(e.hash,newCapacity);
      	  e.next=newTable[index];
      	  newTable[index]=e;
      	  e=next;
      	}while(e!=null);
      }
    }
    table=newTable;
    threshold=(int)(newCapacity*loadFactor);
  }

//--------------------------------------------------------------------//
/**
 * }bvɊ܂܂L[ƒl̑g̐Ԃ
 * @return }bvɊ܂܂L[ƒl̑g̐
 */
  public int size(){
    return size;
  }

//--------------------------------------------------------------------//
/**
 * }bvL[ƒl̑g܂܂Ȃǂʂ
 * @return }bvL[ƒl̑g܂܂Ȃꍇ true
 */
  public boolean isEmpty(){
    return (size==0);
  }

//--------------------------------------------------------------------//
/**
 * }bvw肳ꂽL[܂ނǂʂ
 * @param key }bv܂ނǂʂL[
 * @return }bvw肳ꂽL[܂ޏꍇ true
 */
  public boolean containsKey(double key){
    return containsIntKey((int)key);
  }

//--------------------------------------------------------------------//
/**
 * }bvw肳ꂽL[܂ނǂʂ
 * @param key }bv܂ނǂʂL[
 * @return }bvw肳ꂽL[܂ޏꍇ true
 */
  public boolean containsIntKey(int key){
    int hash=hash(key);
    int index=index(hash,table.length);
    Entry e=table[index];
    while(e!=null){
      if(e.key==key) return true;
      e=e.next;
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * lԂ
 * @param key loL[
 * @return w肳ꂽL[ɑΉl
 */
  public double get(double key){
    int hash=hash((int)key);
    int index=index(hash,table.length);
    Entry e=table[index];
    while(true){
      if(e==null)              return Double.NaN;
      else if(e.getKey()==key) return e.getValue();
      e=e.next;
    }
  }

//--------------------------------------------------------------------//
/**
 * lԂ
 * @param key loL[
 * @return w肳ꂽL[ɑΉl
 *         l݂Ȃꍇ <code>Integer.MIN_VALUE</code>
 */
  public int getInt(int key){
    int hash=hash(key);
    int index=index(hash,table.length);
    Entry e=table[index];
    while(true){
      if(e==null)         return Integer.MIN_VALUE;
      else if(e.key==key) return e.value;
      e=e.next;
    }
  }

//--------------------------------------------------------------------//
/**
 * l}bsO
 * @param key w肳ꂽlɊ֘AtL[
 * @param value w肳ꂽL[ɑΉl
 * @return L[ɑΉlύXOɑ݂ꍇ͂̒lA
 *         ݂Ȃꍇ NaN
 */
  public double put(double key,double value){
    int hash=hash((int)key);
    int index=index(hash,table.length);
    Entry e=table[index];
    while(e!=null){
      if(e.key==key){
      	return e.setValue(value);
      }
      e=e.next;
    }
    modCount++;
    addEntry(hash,(int)key,(int)value,index);
    return Double.NaN;
  }

//--------------------------------------------------------------------//
/**
 * l}bsO
 * @param key w肳ꂽlɊ֘AtL[
 * @param value w肳ꂽL[ɑΉl
 * @return L[ɑΉlύXOɑ݂ꍇ͂̒lA
 *         ݂Ȃꍇ Integer.MIN_VALUE
 */
  public int putInt(int key,int value){
    int hash=hash(key);
    int index=index(hash,table.length);
    Entry e=table[index];
    while(e!=null){
      if(e.key==key){
      	int oldValue=value;
      	e.value=value;
      	return oldValue;
      }
      e=e.next;
    }
    modCount++;
    addEntry(hash,key,value,index);
    return Integer.MIN_VALUE;
  }

//--------------------------------------------------------------------//
/**
 * }bsO폜
 * @param key }bsO폜L[
 * @return 폜ꂽL[ɑΉl
 */
  public double remove(double key){
    Entry e=removeEntry((int)key);
    if(e==null) return Double.NaN;
    else        return e.getValue();
  }

//--------------------------------------------------------------------//
/**
 * }bsO폜
 * @param key }bsO폜L[
 * @return 폜ꂽL[ɑΉl
 */
  public int remove(int key){
    Entry e=removeEntry(key);
    if(e==null) return Integer.MIN_VALUE;
    else        return e.value;
  }

//--------------------------------------------------------------------//
/**
 * }bsO폜
 * @param key }bsO폜L[
 * @return 폜ꂽL[̃Gg[
 */
  protected Entry removeEntry(int key){
    int hash=hash(key);
    int index=index(hash,table.length);
    Entry prev=table[index];
    Entry e=prev;
    while(e!=null){
      if(e.key==key){
      	modCount++;
      	size--;
      	if(prev==e) table[index]=e.next;
      	else        prev.next=e.next;
      	return e;
      }
      prev=e;
      e=e.next;
    }
    return e;
  }

//--------------------------------------------------------------------//
/**
 * }bsOSč폜
 */
  public void clear(){
    modCount++;
    for(int i=0;i<table.length;i++) table[i]=null;
    size=0;
  }

//--------------------------------------------------------------------//
/**
 * }bvɊ܂܂SẴGg[Ԃ
 * @return }bvɊ܂܂SẴGg[i[z
 */
  public NumberMap.Entry[] entries(){
    ArrayList list=new ArrayList(size);
    for(int i=0;i<table.length;i++){
      Entry e=table[i];
      while(e!=null){
      	list.add(e);
      	e=e.next;
      }
    }
    int listSize=list.size();
    Entry es[]=new Entry[listSize];
    for(int i=0;i<listSize;i++){
      es[i]=(Entry)list.get(i);
    }
    return es;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    IntegerMap map=(IntegerMap)super.clone();
    map.table=new Entry[table.length];
    map.size=0;
    map.putAll(this);
    map.modCount=0;
    return map;
  }

//--------------------------------------------------------------------//
/**
 * }bvGg[NX
 */
  protected static class Entry implements NumberMap.Entry{

/** L[̃nbVl */
    protected int hash;

/** Gg[̃L[ */
    protected int key;

/** Gg[̒l */
    protected int value;

/** CfbNXl̎̃Gg[ */
    protected Entry next;

/**
 * }bvGg[\z
 * @param hash L[̃nbVl
 * @param key Gg[̃L[
 * @param value Gg[̒l
 * @param next CfbNXl̎̃Gg[
 */
    protected Entry(int hash,int key,int value,Entry next){
      this.hash=hash;
      this.key=key;
      this.value=value;
      this.next=next;
    }

//--------------------------------------------------------------------//
/**
 * Gg[̃L[Ԃ
 * @return Gg[̃L[
 */
    public double getKey(){
      return (double)key;
    }

//--------------------------------------------------------------------//
/**
 * Gg[̒lԂ
 * @return Gg[̒l
 */
    public double getValue(){
      return (double)value;
    }

//--------------------------------------------------------------------//
/**
 * Gg[̒lu
 * @param value Gg[ɐVݒ肷l
 * @return Gg[̒uO̒l
 */
    public double setValue(double value){
      int oldValue=this.value;
      this.value=(int)value;
      return (double)oldValue;
    }

//--------------------------------------------------------------------//
/**
 * Gg[̓
 * @param o rΏۃIuWFNg
 * @return rΏۃIuWFNg̃Gg[Ɠ
 *         L[ElGg[̏ꍇ true
 */
    public boolean equals(Object o){
      if(o instanceof Entry){
      	Entry e=(Entry)o;
      	return ((key==e.key) && (value==e.value));
      }
      return false;
    }

//--------------------------------------------------------------------//
/**
 * Gg[̃nbVR[hlԂ
 * @return Gg[̃nbVR[hl
 */
    public int hashCode(){
      return (key^value);
    }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
    public String toString(){
      return "key "+key+" = value "+value;
    }
  }
}
