package gui;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Paint;
import java.awt.Point;
import java.awt.datatransfer.Transferable;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.awt.image.VolatileImage;
import java.lang.*;
import javax.swing.Action;
import javax.swing.InputMap;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.KeyStroke;
import javax.swing.event.MouseInputListener;
import gui.transfer.ImageSelection;
import gui.transfer.TransferableData;
import laf.DrawParameter;

//--------------------------------------------------------------------//
/**
 * WplNX
 */
public class BasicPanel extends JPanel
  implements TransferableData,FontResizeable,MouseInputListener{

/** plTCY */
  protected Dimension panelSize;

/** _uobt@OpC[W */
  protected VolatileImage bgImage;

/** _uobt@OpC[W̃OtBbNXReLXg */
  protected Graphics2D bg;

/** fBU[wiJ[p^[ */
  protected Paint ditherPaint;

/** fBU[wigpꍇ true */
  private boolean dither;

/** }EXʒu */
  protected Point mouse;

/** |bvAbvj[ */
  protected JPopupMenu popupMenu;

/**
 * Wpl\z
 */
  public BasicPanel(){
    super();
    mouse=new Point();
    popupMenu=getPopupMenu();
    ditherPaint=null;
    dither=true;
    addMouseListener(this);
    addMouseMotionListener(this);
  }

//--------------------------------------------------------------------//
/**
 * }EX{^̏s
 * @param e }EXANVƂCxg
 */
  public void mousePressed(MouseEvent e){
    mouse.setLocation(e.getX(),e.getY());
    if((popupMenu!=null) && e.isPopupTrigger()){
      popupMenu.show(e.getComponent(),mouse.x,mouse.y);
    }
    repaint();
  }

//--------------------------------------------------------------------//
/**
 * }EX{^𗣂̏s
 * @param e }EXANVƂCxg
 */
  public void mouseReleased(MouseEvent e){
    mouse.setLocation(e.getX(),e.getY());
    if((popupMenu!=null) && e.isPopupTrigger()){
      popupMenu.show(e.getComponent(),mouse.x,mouse.y);
    }
    update();
  }

//--------------------------------------------------------------------//
/**
 * }EXNbN̏s
 * @param e }EXANVƂCxg
 */
  public void mouseClicked(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXplɓ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseEntered(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXplȍs
 * @param e }EXANVƂCxg
 */
  public void mouseExited(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXړ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseMoved(MouseEvent e){
    mouse.setLocation(e.getX(),e.getY());
    update();
  }

//--------------------------------------------------------------------//
/**
 * }EXhbȌs
 * @param e }EXANVƂCxg
 */
  public void mouseDragged(MouseEvent e){
    mouse.setLocation(e.getX(),e.getY());
    update();
  }

//--------------------------------------------------------------------//
/**
 * L[ANVǉ
 * @param action ǉANV
 * @param key ANVL[\
 */
  public void addKeyAction(Action action,String key){
    InputMap imap=getInputMap(WHEN_IN_FOCUSED_WINDOW);
    imap.put(KeyStroke.getKeyStroke(key),action);
    getActionMap().put(action,action);
  }

//--------------------------------------------------------------------//
/**
 * L[ANVǉ
 * @param action ǉANV
 * @param keys ANVL[\i[z
 */
  public void addKeyAction(Action action,String keys[]){
    InputMap imap=getInputMap(WHEN_IN_FOCUSED_WINDOW);
    for(int i=0;i<keys.length;i++){
      imap.put(KeyStroke.getKeyStroke(keys[i]),action);
    }
    getActionMap().put(action,action);
  }

//--------------------------------------------------------------------//
/**
 * \TCYݒ肷
 * @param d \TCY
 */
  public void setViewSize(Dimension d){
    setSize(d);
    setPreferredSize(d);
  }

//--------------------------------------------------------------------//
/**
 * \TCYݒ肷
 * @param width 
 * @param height 
 */
  public void setViewSize(int width,int height){
    setViewSize(new Dimension(width,height));
  }

//--------------------------------------------------------------------//
/**
 * ]f[^Ԃ
 * @return ]f[^ <code>Transferable</code> IuWFNg
 */
  public Transferable getContext(){
    return new ImageSelection(getImage());
  }

//--------------------------------------------------------------------//
/**
 * |bvAbvj[Ԃ<br>
 * ̃NXł null Ԃ
 * @return |bvAbvj[
 */
  public JPopupMenu getPopupMenu(){
    return null;
  }

//--------------------------------------------------------------------//
/**
 * tHgTCYύX
 * @param dsize TCY̕ύXʂ\<br>
 *              g傷Ƃ͐AkƂ͕̒l
 */
  public void resizeFont(int dsize){
    Font font=bg.getFont();
    String name=font.getFontName();
    int style=font.getStyle();
    int size=font.getSize();
    int newSize=Math.max(Math.min
      (size+dsize,FontResizeable.MAX_FONT_SIZE),
       FontResizeable.MIN_FONT_SIZE);
    bg.setFont(new Font(name,style,newSize));
    getGraphics().setFont(new Font(name,style,newSize));
  }

//--------------------------------------------------------------------//
/**
 * fBU[wi̎gpݒ肷
 * @param dither fBU[wigpꍇ true
 */
  public void setDither(boolean dither){
    this.dither=dither;
  }

//--------------------------------------------------------------------//
/**
 * ʃC[WԂ
 * @return ʃC[W
 */
  public BufferedImage getImage(){
    Color bgColor=DrawParameter.getBackgroundColor();
    Color fgColor=DrawParameter.getForegroundColor();
    DrawParameter.setBackgroundColor(Color.WHITE);
    if(fgColor.equals(Color.WHITE)){
      DrawParameter.setForegroundColor(Color.BLACK);
    }
    boolean dither0=dither;
    setDither(false);
    setPaint();
    BufferedImage image=new BufferedImage
      (panelSize.width,panelSize.height,BufferedImage.TYPE_INT_ARGB);
    paintModel(image.createGraphics());
    DrawParameter.setBackgroundColor(bgColor);
    DrawParameter.setForegroundColor(fgColor);
    setDither(dither0);
    return image;
  }

//--------------------------------------------------------------------//
/**
 * 
 * @param g OtBbNXReLXg
 */
  protected void printComponent(Graphics g){
    Color bgColor=DrawParameter.getBackgroundColor();
    Color fgColor=DrawParameter.getForegroundColor();
    DrawParameter.setBackgroundColor(Color.WHITE);
    if(fgColor.equals(Color.WHITE)){
      DrawParameter.setForegroundColor(Color.BLACK);
    }
    boolean dither0=dither;
    setDither(false);
    setPaint();
    paintModel((Graphics2D)g);
    DrawParameter.setBackgroundColor(bgColor);
    DrawParameter.setForegroundColor(fgColor);
    setDither(dither0);
  }

//--------------------------------------------------------------------//
/**
 * ĕ`悷
 */
  public void update(){
    if(bg==null) setPaint();
    paintModel(bg);
    getGraphics().drawImage(bgImage,0,0,this);
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  protected void paintComponent(Graphics g){
    setPaint();
    paintModel(bg);
    g.drawImage(bgImage,0,0,this);
  }

//--------------------------------------------------------------------//
/**
 * ʂ̐ݒ
 */
  protected void setPaint(){
    panelSize=getSize();
    bgImage=createVolatileImage(panelSize.width,panelSize.height);
    bg=bgImage.createGraphics();
    if(dither){
      ditherPaint=createDitherPaint(DrawParameter.getBackgroundColor());
    }
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  protected void paintModel(Graphics2D g){
  }

//--------------------------------------------------------------------//
/**
 * wihׂ
 * @param g `悷OtBbNXReLXg
 */
  protected void paintBackground(Graphics2D g){
    if((ditherPaint!=null) && dither){
      paintBackground(g,ditherPaint);
    }
    else{
      paintBackground(g,DrawParameter.getBackgroundColor());
    }
  }

//--------------------------------------------------------------------//
/**
 * wihׂ
 * @param g `悷OtBbNXReLXg
 * @param backgroundPaint wiJ[p^[
 */
  protected void paintBackground(Graphics2D g,Paint backgroundPaint){
    g.setPaint(backgroundPaint);
    g.fillRect(0,0,panelSize.width,panelSize.height);
  }

//--------------------------------------------------------------------//
/**
 * fBU[J[p^[쐬
 * @param backgroundColor wiF
 * @return fBU[J[p^[
 */
  protected Paint createDitherPaint(Color backgroundColor){
    Color brightColor=backgroundColor.brighter().brighter();
    Color darkColor=backgroundColor.darker().darker();
    Point brightPoint=new Point(0,0);
    Point darkPoint=new Point(0,panelSize.height);
    return new GradientPaint(brightPoint,brightColor,
      	      	      	     darkPoint,darkColor);
  }
}
