package gui;
import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.lang.*;
import java.text.DecimalFormat;

//--------------------------------------------------------------------//
/**
 * J[o[̃NX
 */
public abstract class ColorBar{

/** li[z */
  protected static final DecimalFormat
    FORMS[]={new DecimalFormat("0.00E0"),
      	     new DecimalFormat("#####0.0"),
      	     new DecimalFormat("###0.0###")};

/** J[o[͈͂̍ŏl */
  protected static final double MINIMUM_RANGE=1.0E-12;

/** J[o[\̋ */
  protected static final int MARGIN=2;

/** ŏl */
  protected double minValue;

/** ől */
  protected double maxValue;

/** W */
  protected double coef;

/**
 * ŏl 0 , ől 1 ŃJ[o[\z
 */
  protected ColorBar(){
    this(0.0,1.0);
  }

/**
 * ŏl 0 , ől <code>maxValue</code> ŃJ[o[\z
 * @param maxValue ől
 */
  protected ColorBar(int maxValue){
    this(0.0,(double)maxValue);
  }

/**
 * ŏl 0 , ől <code>maxValue</code> ŃJ[o[\z
 * @param maxValue ől
 */
  protected ColorBar(double maxValue){
    this(0.0,maxValue);
  }

/**
 * f[^͈͂w肵ăJ[o[\z
 * @param minValue ŏl
 * @param maxValue ől
 */
  protected ColorBar(int minValue,int maxValue){
    this((double)minValue,(double)maxValue);
  }

/**
 * f[^͈͂w肵ăJ[o[\z
 * @param minValue ŏl
 * @param maxValue ől
 */
  protected ColorBar(double minValue,double maxValue){
    set(minValue,v2);
  }

//--------------------------------------------------------------------//
/**
 * 0 ` 1 ̒l <code>value</code> ɑ΂J[o[̐FԂ
 * @param value Qƒl
 * @return J[o[̐F
 */
  protected abstract Color normColor(double value);

//--------------------------------------------------------------------//
/**
 * l <code>value</code> ɑ΂J[o[̐FԂ
 * @param value Qƒl
 * @return J[o[̐F
 */
  public Color color(double value){
    return normColor(coef*(value-minValue));
  }

//--------------------------------------------------------------------//
/**
 * l <code>value</code> ɑ΂J[o[̐FԂ
 * @param value Qƒl
 * @return J[o[̐F
 */
  public Color color(int value){
    return color((double)value);
  }

//--------------------------------------------------------------------//
/**
 * f[^͈͂ݒ肷
 * @param v1 ŏl
 * @param v2 ől
 */
  public void set(int v1,int v2){
    set((double)v1,(double)v2);
  }

//--------------------------------------------------------------------//
/**
 * f[^͈͂ݒ肷
 * @param v1 ŏl
 * @param v2 ől
 */
  public void set(double v1,double v2){
    minValue=Math.min(v1,v2);
    maxValue=Math.max(v1,v2);
    if((maxValue-minValue)<MINIMUM_RANGE) coef=0.0;
    else                                  coef=1.0/(maxValue-minValue);
  }

//--------------------------------------------------------------------//
/**
 * J[o[`悷
 * @param g `悷OtBbNXReLXg
 * @param rect J[o[̕`͈
 * @param textColor \F
 */
  public void drawVerticalBar(Graphics g,Rectangle rect,
      	      	      	      Color textColor){
    double dv=(maxValue-minValue)/(double)(rect.height-1);
    double value=minValue;
    int lx2=(int)rect.getMaxX();
    int ly=(int)rect.getMaxY()-1;
    for(int i=0;i<rect.height;i++){
      g.setColor(color(value));
      g.drawLine(rect.x,ly,lx2,ly);
      ly--;
      value+=dv;
    }
    g.setColor(textColor);
    int textX=lx2+MARGIN;
    int textY=g.getFontMetrics().getHeight()/2;
    g.drawString(barLabel(maxValue),textX,rect.y+textY);
    g.drawString(barLabel(minValue),textX,(int)rect.getMaxY()+textY);
  }

//--------------------------------------------------------------------//
/**
 * J[o[`悷
 * @param g `悷OtBbNXReLXg
 * @param rect J[o[̕`͈
 * @param textColor \F
 */
  public void drawHorizontalBar(Graphics g,Rectangle rect,
      	      	      	      	Color textColor){
    double dv=(maxValue-minValue)/(double)(rect.width-1);
    double value=minValue;
    int lx=rect.x;
    int ly2=(int)rect.getMaxY();
    for(int i=0;i<rect.width;i++){
      g.setColor(color(value));
      g.drawLine(lx,rect.y,lx,ly2);
      lx++;
      value+=dv;
    }
    g.setColor(textColor);
    FontMetrics fm=g.getFontMetrics();
    String label1=barLabel(minValue);
    String label2=barLabel(maxValue);
    int textX=fm.stringWidth(label1)/2;
    int textY=ly2+fm.getHeight()+MARGIN;
    g.drawString(label1,rect.x-textX,textY);
    g.drawString(label2,(int)rect.getMaxX()-textX,textY);
  }

//--------------------------------------------------------------------//
/**
 * l <code>value</code> ̕\Ԃ
 * @param value l
 * @return l̕\
 */
  private String barLabel(double value){
    double vabs=Math.abs(value);
    if(vabs>=1.0E5){
      return FORMS[0].format(value);
    }
    else if((vabs>=1.0) || (value==0.0)){
      return FORMS[1].format(value);
    }
    else if(vabs>=0.001){
      return FORMS[2].format(value);
    }
    else{
      return FORMS[0].format(value);
    }
  }

//--------------------------------------------------------------------//
/**
 * iKJ[o[NX
 */
  public static class Index extends ColorBar{

/** ϏJ[o[IuWFNg */
    private ColorBar colorBar;

/** iKvZ邽߂̌W */
    private double coef1;

/** iKvZ邽߂̌W */
    private double coef2;

/** iK̐ */
    public int step;

/**
 * X[XJ[o[ <code>colorbar</code> K <code>step</code>
 * ɂĒiKJ[o[NX\z
 * @param colorBar ϏJ[o[
 * @param step iK̐
 */
    public Index(ColorBar colorBar,int step){
      super(colorBar.minValue,colorBar.maxValue);
      this.colorBar=colorBar;
      this.step=step;
      coef1=(double)(step+1);
      coef2=1.0/(double)step;
    }

//--------------------------------------------------------------------//
/**
 * f[^͈͂ݒ肷
 * @param v1 ŏl
 * @param v2 ől
 */
    public void set(double v1,double v2){
      super.set(v1,v2);
      if(colorBar!=null) colorBar.set(v1,v2);
    }

//--------------------------------------------------------------------//
/**
 * 0 ` 1 l <code>value</code> ɑ΂J[o[̐FԂ
 * @param value Qƒl
 * @return J[o[̐F
 */
    protected Color normColor(double value){
      return colorBar.normColor(coef2*Math.floor(coef1*value));
    }
  }

//--------------------------------------------------------------------//
/**
 * t]J[o[NX
 */
  public static class Inverse extends ColorBar{

/** ϏJ[o[ */
    private ColorBar colorBar;

/**
 * J[o[ <code>colorBar</code> ̕\Ft]
 * J[o[NX\z
 * @param colorBar ϏJ[o[
 */
    public Inverse(ColorBar colorBar){
      super(colorBar.minValue,colorBar.maxValue);
      this.colorBar=colorBar;
    }

//--------------------------------------------------------------------//
/**
 * f[^͈͂ݒ肷
 * @param v1 ŏl
 * @param v2 ől
 */
    public void set(double v1,double v2){
      super.set(v1,v2);
      if(colorBar!=null) colorBar.set(v1,v2);
    }

//--------------------------------------------------------------------//
/**
 * 0 ` 1 l <code>value</code> ɑ΂J[o[̐FԂ
 * @param value Qƒl
 * @return J[o[̐F
 */
    protected Color normColor(double value){
      return colorBar.normColor(1.0-value);
    }
  }

//--------------------------------------------------------------------//
/**
 * WJ[o[NX<br>
 * l|΁|Ԃƕω
 */
  public static class Standard extends ColorBar{

/**
 * ŏl 0 , ől 1 ŃJ[o[\z
 */
    public Standard(){
      super();
    }

/**
 * ŏl 0 , ől <code>maxValue</code> ŃJ[o[\z
 * @param maxValue ől
 */
    public Standard(int maxValue){
      super(maxValue);
    }

/**
 * ŏl 0 , ől <code>maxValue</code> ŃJ[o[\z
 * @param maxValue ől
 */
    public Standard(double maxValue){
      super(maxValue);
    }

/**
 * f[^͈͂w肵ăJ[o[\z
 * @param minValue ŏl
 * @param maxValue ől
 */
    public Standard(int minValue,int maxValue){
      super(minValue,maxValue);
    }

/**
 * f[^͈͂w肵ăJ[o[\z
 * @param minValue ŏl
 * @param maxValue ől
 */
    public Standard(double minValue,double maxValue){
      super(minValue,maxValue);
    }

//--------------------------------------------------------------------//
/**
 * 0 ` 1 l <code>value</code> ɑ΂J[o[̐FԂ
 * @param value Qƒl
 * @return J[o[̐F
 */
    protected Color normColor(double value){
      if(value<=0.0){
      	return Color.BLUE;
      }
      else if(value<0.25){
      	int g=(int)Math.rint(1020.0*value);
      	return new Color(0,g,255);
      }
      else if(value<0.5){
      	int b=(int)Math.rint(1020.0*(0.5-value));
      	return new Color(0,255,b);
      }
      else if(value<0.75){
      	int r=(int)Math.rint(1020.0*(value-0.5));
      	return new Color(r,255,0);
      }
      else if(value<1.0){
      	int g=(int)Math.rint(1020.0*(1.0-value));
      	return new Color(255,g,0);
      }
      else{
      	return Color.RED;
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * O[XP[J[o[NX<br>
 * l獕|DF|ƕω
 */
  public static class Gray extends ColorBar{

/**
 * ŏl 0 , ől 1 ŃJ[o[\z
 */
    public Gray(){
      super();
    }

/**
 * ŏl 0 , ől <code>maxValue</code> ŃJ[o[\z
 * @param maxValue ől
 */
    public Gray(int maxValue){
      super(maxValue);
    }

/**
 * ŏl 0 , ől <code>maxValue</code> ŃJ[o[\z
 * @param maxValue ől
 */
    public Gray(double maxValue){
      super(maxValue);
    }

/**
 * f[^͈͂w肵ăJ[o[\z
 * @param minValue ŏl
 * @param maxValue ől
 */
    public Gray(int minValue,int maxValue){
      super(minValue,maxValue);
    }

/**
 * f[^͈͂w肵ăJ[o[\z
 * @param minValue ŏl
 * @param maxValue ől
 */
    public Gray(double minValue,double maxValue){
      super(minValue,maxValue);
    }

//--------------------------------------------------------------------//
/**
 * 0 ` 1 l <code>value</code> ɑ΂J[o[̐FԂ
 * @param value Qƒl
 * @return J[o[̐F
 */
    protected Color normColor(double value){
      if(value<=0.0){
      	return Color.BLACK;
      }
      else if(value>=1.0){
      	return Color.WHITE;
      }
      else{
      	int v=(int)(255.0*value);
      	return new Color(v,v,v);
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * FJ[o[NX<br>
 * l率||΁|Ԃƕω
 */
  public static class Rainbow extends ColorBar{

/**
 * ŏl 0 , ől 1 ŃJ[o[\z
 */
    public Rainbow(){
      super();
    }

/**
 * ŏl 0 , ől <code>maxValue</code> ŃJ[o[\z
 * @param maxValue ől
 */
    public Rainbow(int maxValue){
      super(maxValue);
    }

/**
 * ŏl 0 , ől <code>maxValue</code> ŃJ[o[\z
 * @param maxValue ől
 */
    public Rainbow(double maxValue){
      super(maxValue);
    }

/**
 * f[^͈͂w肵ăJ[o[\z
 * @param minValue ŏl
 * @param maxValue ől
 */
    public Rainbow(int minValue,int maxValue){
      super(minValue,maxValue);
    }

/**
 * f[^͈͂w肵ăJ[o[\z
 * @param minValue ŏl
 * @param maxValue ől
 */
    public Rainbow(double minValue,double maxValue){
      super(minValue,maxValue);
    }

//--------------------------------------------------------------------//
/**
 * 0 ` 1 l <code>value</code> ɑ΂J[o[̐FԂ
 * @param value Qƒl
 * @return J[o[̐F
 */
    protected Color normColor(double value){
      if(value<=0.0){
      	return Color.MAGENTA;
      }
      else if(value<0.2){
      	int r=(int)Math.rint(1275.0*(0.2-value));
      	return new Color(r,0,255);
      }
      else if(value<0.4){
      	int g=(int)Math.rint(1275.0*(value-0.2));
      	return new Color(0,g,255);
      }
      else if(value<0.6){
      	int b=(int)Math.rint(1275.0*(0.6-value));
      	return new Color(0,255,b);
      }
      else if(value<0.8){
      	int r=(int)Math.rint(1275.0*(value-0.6));
      	return new Color(r,255,0);
      }
      else if(value<1.0){
      	int g=(int)Math.rint(1275.0*(1.0-value));
      	return new Color(255,g,0);
      }
      else{
      	return Color.RED;
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * ΉJ[o[NX<br>
 * l獕|ԁ||ƕω
 */
  public static class Flame extends ColorBar{

/** 1 / 3 */
    public static double V1_3=1.0/3.0;

/** 2 / 3 */
    public static double V2_3=2.0/3.0;

/**
 * ŏl 0 , ől 1 ŃJ[o[\z
 */
    public Flame(){
      super();
    }

/**
 * ŏl 0 , ől <code>maxValue</code> ŃJ[o[\z
 * @param maxValue ől
 */
    public Flame(int maxValue){
      super(maxValue);
    }

/**
 * ŏl 0 , ől <code>maxValue</code> ŃJ[o[\z
 * @param maxValue ől
 */
    public Flame(double maxValue){
      super(maxValue);
    }

/**
 * f[^͈͂w肵ăJ[o[\z
 * @param minValue ŏl
 * @param maxValue ől
 */
    public Flame(int minValue,int maxValue){
      super(minValue,maxValue);
    }

/**
 * f[^͈͂w肵ăJ[o[\z
 * @param minValue ŏl
 * @param maxValue ől
 */
    public Flame(double minValue,double maxValue){
      super(minValue,maxValue);
    }

//--------------------------------------------------------------------//
/**
 * 0 ` 1 l <code>value</code> ɑ΂J[o[̐FԂ
 * @param value Qƒl
 * @return J[o[̐F
 */
    protected Color normColor(double value){
      if(value<=0.0){
      	return Color.BLACK;
      }
      else if(value<V1_3){
      	int r=(int)Math.rint(765.0*value);
      	return new Color(r,0,0);
      }
      else if(value<V2_3){
      	int g=(int)Math.rint(765.0*(value-V1_3));
      	return new Color(255,g,0);
      }
      else if(value<1.0){
      	int b=(int)Math.rint(765.0*(value-V2_3));
      	return new Color(255,255,b);
      }
      else{
      	return Color.WHITE;
      }
    }
  }
}
