package gui.print;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.print.PageFormat;
import java.awt.print.Paper;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * R|[lgNX
 */
public class PrintComponent implements Printable{

/** ΏۃR|[lg */
  private Component component;

/**
 * R|[lgIuWFNg\z
 * @param component ΏۃR|[lg
 */
  public PrintComponent(Component component){
    this.component=component;
  }

//--------------------------------------------------------------------//
/**
 * 
 * @param g y[W`悳ReLXg
 * @param pf `悳y[W̃TCYƈ
 * @param pageIndex `悳y[W̃[n܂CfbNX
 * @return y[W̕`ɐꍇ <code>PAGE_EXISTS</code>,
 *         <code>pageIndex</code> Ŏw肳ꂽy[W݂Ȃꍇ
 *         <code>NO_SUCH_PAGE</code>
 * @throws PrinterException fꂽꍇ
 */
  public int print(Graphics g,PageFormat pf,int pageIndex)
    throws PrinterException{
    if(pageIndex==0){
      g.translate((int)pf.getImageableX(),(int)pf.getImageableY());
      Dimension size=(Dimension)component.getSize().clone();
      Paper paper=pf.getPaper();
      if(pf.getOrientation()==PageFormat.LANDSCAPE){
      	component.setSize((int)paper.getImageableHeight(),
      	      	      	  (int)paper.getImageableWidth());
      }
      else if(pf.getOrientation()==PageFormat.PORTRAIT){
      	component.setSize((int)paper.getImageableWidth(),
      	      	      	  (int)paper.getImageableHeight());
      }
      component.printAll(g);
      component.setSize(size);
      return PAGE_EXISTS;
    }
    else{
      return NO_SUCH_PAGE;
    }
  }
}
