package gui.print;
import java.lang.*;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.SimpleDoc;
import javax.print.attribute.Attribute;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.attribute.standard.*;

//--------------------------------------------------------------------//
/**
 * ǗNX
 */
public class PrintManager{

/** ftHg̃v^ */
  public static final PrintService
    DEFAULT_SERVICE=PrintServiceLookup.lookupDefaultPrintService();

/** f[^` */
  private DocFlavor flavor;

/** Zbg */
  private PrintRequestAttributeSet attributeSet;

/** ݑIĂv^ */
  protected PrintService currentService;

/**
 * ǗIuWFNg\z
 * @param flavor f[^`
 */
  public PrintManager(DocFlavor flavor){
    this.flavor=flavor;
    attributeSet=new HashPrintRequestAttributeSet();
    setDefaultAttributes();
  }

//--------------------------------------------------------------------//
/**
 * ftHgݒ肷
 */
  private void setDefaultAttributes(){
    attributeSet.add(OrientationRequested.LANDSCAPE);
    attributeSet.add(MediaSizeName.ISO_A4);
    attributeSet.add(Chromaticity.COLOR);
    attributeSet.add(new Copies(1));
    setPrinter();
  }

//--------------------------------------------------------------------//
/**
 * ύX
 * @param attribute ݒ肷
 */
  public void setAttribute(Attribute attribute){
    attributeSet.add(attribute);
    setPrinter();
  }

//--------------------------------------------------------------------//
/**
 * f[^`Ԃ
 * @return f[^`
 */
  public DocFlavor getDocFlavor(){
    return flavor;
  }

//--------------------------------------------------------------------//
/**
 * ZbgԂ
 * @return Zbg
 */
  public PrintRequestAttributeSet getAttributeSet(){
    return attributeSet;
  }

//--------------------------------------------------------------------//
/**
 * \ȃv^ݒ肷
 */
  public void setPrinter(){
    PrintService services[]=            // gp\ȃv^ꗗ
      PrintServiceLookup.lookupPrintServices(flavor,attributeSet);
    if(services.length<=0){
      currentService=null;
    }
    else{
      for(int i=0;i<services.length;i++){
      	if(services[i].equals(DEFAULT_SERVICE)){
      	  currentService=DEFAULT_SERVICE;
      	  return;
      	}
      }
      currentService=services[0];
    }
  }

//--------------------------------------------------------------------//
/**
 * Ԃ
 * @param attribute õJeSw肷
 * @return w肳ꂽƓJeŠ݂̈
 */
  public Attribute getAttribute(Attribute attribute){
    return attributeSet.get(attribute.getCategory());
  }

//--------------------------------------------------------------------//
/**
 * WuԂ
 * @return IĂv^̈Wu
 */
  public DocPrintJob getPrintJob(){
    if(currentService==null){
      return null;
    }
    else{
      return currentService.createPrintJob();
    }
  }

//--------------------------------------------------------------------//
/**
 * ݒ_CAO\
 * @return ͂ňsꍇ true
 */
  public boolean showDialog(){
    if(currentService==null){
      return false;
    }
    else{
      PrinterJob job=PrinterJob.getPrinterJob();
      try{
      	job.setPrintService(currentService);
      }
      catch(PrinterException ex){
      }
      return job.printDialog(attributeSet);
    }
  }

//--------------------------------------------------------------------//
/**
 * s
 * @param printData f[^
 * @throws IllegalArgumentException
 *         f[^f[^`ɑΉĂȂƂ
 * @throws PrintException Wuŉ炩̃G[Ƃ
 */
  public void print(Object printData)
    throws IllegalArgumentException,PrintException{
    DocPrintJob job=getPrintJob();
    if(job==null) return;
    job.print(new SimpleDoc(printData,flavor,null),attributeSet);
  }
}
