package gui.table;
import java.awt.Font;
import java.awt.Point;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.lang.*;
import java.util.HashSet;
import javax.swing.*;
import javax.swing.table.*;
import gui.*;
import gui.transfer.TransferableData;

//--------------------------------------------------------------------//
/**
 * We[uNX
 */
public class BasicTable extends JTable
  implements TransferableData,FontResizeable{

/** oZ̈ʒũZbg */
  private HashSet cellPositionSet;

/**
 * e[uIuWFNg\z
 */
  public BasicTable(){
    this(new DefaultTableModel());
  }

/**
 * e[uIuWFNg\z
 * @param model f[^f
 */
  public BasicTable(DefaultTableModel model){
    super(model);
    setAutoResizeMode(AUTO_RESIZE_OFF);
    setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
    setRowSelectionAllowed(false);
    setColumnSelectionAllowed(false);
    cellPositionSet=new HashSet();
    setDefaultRenderer
      (Object.class,new BasicTableCellRenderer(cellPositionSet));
  }

//--------------------------------------------------------------------//
/**
 * ]f[^Ԃ
 * @return ]f[^ <code>Transferable</code> IuWFNg
 */
  public Transferable getContext(){
    return new StringSelection(getDataFromSelectedCells());
  }

//--------------------------------------------------------------------//
/**
 * I𕔕̃f[^Ԃ
 * @return e[uI𕔕̃f[^̕\
 */
  public String getDataFromSelectedCells(){
    int row[]=getSelectedRows();
    int column[]=getSelectedColumns();
    StringBuffer sb=new StringBuffer();
    for(int i=0;i<row.length;i++){
      for(int j=0;j<column.length-1;j++){
      	Object value=getValueAt(row[i],column[j]);
      	if(value!=null) sb.append(value);
      	sb.append('\t');
      }
      Object value=getValueAt(row[i],column[column.length-1]);
      if(value!=null) sb.append(value);
      sb.append('\n');
    }
    return sb.toString();
  }

//--------------------------------------------------------------------//
/**
 * e[uŜ̃f[^Ԃ
 * @return e[uŜ̃f[^̕\
 */
  public String getDataFromAllCells(){
    int rowCount=getRowCount();
    int columnCount=getColumnCount();
    StringBuffer sb=new StringBuffer();
    for(int i=0;i<rowCount;i++){
      for(int j=0;j<columnCount-1;j++){
      	Object value=getValueAt(i,j);
      	if(value!=null) sb.append(value);
      	sb.append('\t');
      }
      Object value=getValueAt(i,columnCount-1);
      if(value!=null) sb.append(value);
      sb.append('\n');
    }
    return sb.toString();
  }

//--------------------------------------------------------------------//
/**
 * IꂽSĂ̍s̃CfbNXԂ
 * @return IꂽSĂ̍s̃CfbNXi[鐮z
 */
  public int[] getSelectedRows(){
    if(getRowSelectionAllowed()){
      return super.getSelectedRows();
    }
    else{
      int row[]=new int[getRowCount()];
      for(int i=0;i<row.length;i++) row[i]=i;
      return row;
    }
  }

//--------------------------------------------------------------------//
/**
 * IꂽSẴ̗CfbNXԂ
 * @return IꂽSẴ̗CfbNXi[鐮z
 */
  public int[] getSelectedColumns(){
    if(getColumnSelectionAllowed()){
      return super.getSelectedColumns();
    }
    else{
      int column[]=new int[getColumnCount()];
      for(int i=0;i<column.length;i++) column[i]=i;
      return column;
    }
  }

//--------------------------------------------------------------------//
/**
 * tHgTCYύX
 * @param dsize TCY̕ύXʂ\<br>
 *              g傷Ƃ͐AkƂ͕̒l
 */
  public void resizeFont(int dsize){
    Font font=getFont();
    String name=font.getFontName();
    int style=font.getStyle();
    int size=font.getSize();
    int newSize=Math.max(Math.min
      (size+dsize,FontResizeable.MAX_FONT_SIZE),
       FontResizeable.MIN_FONT_SIZE);
    setFont(new Font(name,style,newSize));
    int newHeight=Math.max(getRowHeight()+newSize-size,1);
    setRowHeight(newHeight);
  }

//--------------------------------------------------------------------//
/**
 * oZݒ肷<br>
 * oZ͕\ς
 * @param row Z̍s
 * @param column Z̗
 */
  public void setExtractedCell(int row,int column){
    cellPositionSet.add(new CellPosition(row,column));
  }

//--------------------------------------------------------------------//
/**
 * oZ̐ݒ
 */
  public void clearExtractedCell(){
    cellPositionSet.clear();
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ<br>
 * e[uŜ̃f[^̕\
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return getDataFromAllCells();
  }
}
