package worldmap;
import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.lang.*;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import gui.ColorIcon;
import laf.CommandMap;
import laf.WordMap;

//--------------------------------------------------------------------//
/**
 * }bv̈쐬_CAO
 */
public class RegionDialog{

/** _CAO{^ */
  protected static final String
    BUTTONS[]={CommandMap.get(CommandMap.SET),
      	       CommandMap.get(CommandMap.CANCEL)};

/** }bv̈於̓tB[h */
  protected JTextField nameField;

/** }bv̈\Fݒ{^ */
  protected JButton colorButton;

/** _CAȌL */
  protected Component base;

/** }bv̈\F */
  protected Color color;

/**
 * }bv̈쐬_CAO\z
 * @param base _CAȌL
 * @param region }bv̈̏l
 */
  public RegionDialog(Component base,Region region){
    if(region==null){
      nameField=new JTextField("name1",20);
      color=Color.WHITE;
    }
    else{
      nameField=new JTextField(region.getName(),20);
      color=region.getColor();
    }
    colorButton=new JButton(new ColorSetAction(base,this));
    nameField.setBorder(new TitledBorder
      (WordMap.get(WordMap.REGION_NAME)));
  }

//--------------------------------------------------------------------//
/**
 * ̓_CAO\
 * @param base _CAȌL
 * @param region }bv̈̏l
 * @return 쐬ꂽ}bv̈
 */
  public static Region showDialog(Component base,Region region){
    RegionDialog dialog=new RegionDialog(base,region);
    if(dialog.showInputDialog()==0){
      return dialog.getRegion();
    }
    else{
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * \Fݒ肷
 * @param color }bv̈\F
 */
  public void setColor(Color color){
    this.color=color;
  }

//--------------------------------------------------------------------//
/**
 * \FԂ
 * @return }bv̈\F
 */
  public Color getColor(){
    return color;
  }

//--------------------------------------------------------------------//
/**
 * ̓_CAO\
 * @return [UIIvV\l
 */
  public int showInputDialog(){
    Object fields[]={nameField,colorButton};
    return JOptionPane.showOptionDialog
      	     (base,fields,WordMap.get(WordMap.REGION),
      	      JOptionPane.DEFAULT_OPTION,JOptionPane.PLAIN_MESSAGE,
      	      null,BUTTONS,BUTTONS[0]);
  }

//--------------------------------------------------------------------//
/**
 * 쐬ꂽ}bv̈o
 * @return 쐬ꂽ}bv̈
 */
  public Region getRegion(){
    return new Region(nameField.getText(),color);
  }

//--------------------------------------------------------------------//
/**
 * FݒANV
 */
  public static class ColorSetAction extends AbstractAction{

/** _CAȌL */
    private Component base;

/** }bv̈쐬_CAO */
    private RegionDialog dialog;

/** \FACR */
    private ColorIcon icon;

/**
 * ANVIuWFNg\z
 * @param base _CAȌL
 * @param dialog }bv̈쐬_CAO
 */
    public ColorSetAction(Component base,RegionDialog dialog){
      putValue(NAME,actionName());
      icon=new ColorIcon(dialog.getColor(),base);
      putValue(SMALL_ICON,icon);
      this.base=base;
      this.dialog=dialog;
    }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param base _CAȌL
 * @param dialog }bv̈쐬_CAO
 * @param actionIcon ACR
 */
    public ColorSetAction(Component base,RegionDialog dialog,
      	      	      	  Icon actionIcon){
      putValue(SMALL_ICON,actionIcon);
      putValue(SHORT_DESCRIPTION,actionName());
      icon=new ColorIcon(dialog.getColor(),base);
      this.base=base;
      this.dialog=dialog;
    }

//--------------------------------------------------------------------//
/**
 * Fݒ肷
 * @param e ANVƂCxg
 */
    public void actionPerformed(ActionEvent e){
      Color color=JColorChooser.showDialog
      	(base,WordMap.get(WordMap.COLOR),dialog.getColor());
      if(color!=null){
      	dialog.setColor(color);
      	icon.setColor(color);
      }
    }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
    public static String actionName(){
      return WordMap.get(WordMap.COLOR);
    }
  }
}
