package worldmap;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.lang.*;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import gui.BasicScrollPane;
import gui.ExitAction;
import laf.WordMap;
import resourcemanager.IconManager;

//--------------------------------------------------------------------//
/**
 * n}\t[
 */
public class WorldMapFrame extends JFrame{

/** ftHg`ʃTCY */
  public static final Dimension DEFAULT_SIZE=new Dimension(600,400);

/** ACR摜t@C */
  public static final String ICON_NAME="WorldMapIcon.png";

/** n}\pl */
  protected WorldMapPanel panel;

/** Q}bvf[^f */
  protected WorldMapModel model;

/** }bv̈惊Xg */
  protected RegionList list;

/**
 * n}\t[\z
 */
  public WorldMapFrame(){
    super(WordMap.get(WordMap.TITLE));
    model=new WorldMapModel();
    list=new RegionList(model);
    panel=new WorldMapPanel(model);

    setJMenuBar(new WorldMapMenuBar(this));
    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(new BasicScrollPane(panel),
      	      	      	 BorderLayout.CENTER);
    getContentPane().add(mapControlPanel(),BorderLayout.EAST);

    setBounds(0,0,DEFAULT_SIZE.width,DEFAULT_SIZE.height);
    setIconImage(IconManager.getImage(ICON_NAME));
    setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    addWindowListener(new ExitAction.WinExitEventHandler(this));
  }

//--------------------------------------------------------------------//
/**
 * Q}bvf[^fԂ
 * @return Q}bvf[^f
 */
  public WorldMapModel getModel(){
    return model;
  }

//--------------------------------------------------------------------//
/**
 * }bv̈惊XgԂ
 * @return }bv̈惊Xg
 */
  public RegionList getRegionList(){
    return list;
  }

//--------------------------------------------------------------------//
/**
 * n}\plԂ
 * @return n}\pl
 */
  public WorldMapPanel getPanel(){
    return panel;
  }

//--------------------------------------------------------------------//
/**
 * }bvRg[pl쐬
 * @return }bvRg[pl
 */
  private JPanel mapControlPanel(){
    JPanel panel1=new JPanel(new GridLayout(1,2));
    panel1.add(new JButton(new ZoominAction(this)));
    panel1.add(new JButton(new ZoomoutAction(this)));

    JPanel panel=new JPanel(new BorderLayout());
    panel.add(panel1,BorderLayout.NORTH);
    panel.add(new RegionListPanel(this),BorderLayout.CENTER);

    return panel;
  }
}
