package worldmap;
import java.lang.*;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JRadioButtonMenuItem;
import gui.AcceleratorMenu;
import gui.ExitAction;
import gui.VersionInfoAction;
import gui.print.PrintComponentAction;
import laf.CommandMap;
import laf.WordMap;
import resourcemanager.IconManager;
import worldmap.io.DataLoadAction;
import worldmap.io.DataSaveAction;

//--------------------------------------------------------------------//
/**
 * j[o[NX
 */
public class WorldMapMenuBar extends JMenuBar{

/**
 * j[o[\z
 * @param frame n}\t[
 */
  public WorldMapMenuBar(WorldMapFrame frame){
    super();
    add(fileMenu(frame));
    add(viewMenu(frame));
    add(helpMenu(frame));
  }

//--------------------------------------------------------------------//
/**
 * File j[쐬
 * @param frame n}\t[
 * @return Filej[
 */
  private JMenu fileMenu(WorldMapFrame frame){
    AcceleratorMenu fileMenu=
      new AcceleratorMenu(CommandMap.get(CommandMap.FILE));

    fileMenu.add(new NewDataAction(frame),"ctrl N");
    fileMenu.add(new DataLoadAction(frame),"ctrl L");
    fileMenu.add(new DataSaveAction(frame),"ctrl S");
    fileMenu.addSeparator();
    fileMenu.add(new PrintComponentAction(frame.getPanel()),"ctrl P");
    fileMenu.addSeparator();
    fileMenu.add(new ExitAction(frame),"ctrl E");

    return fileMenu;
  }

//--------------------------------------------------------------------//
/**
 * View j[쐬
 * @param frame n}\t[
 * @return Viewj[
 */
  private JMenu viewMenu(WorldMapFrame frame){
    AcceleratorMenu viewMenu=
      new AcceleratorMenu(WordMap.get(WordMap.VIEW_SETTING));

    JMenuItem area=new JRadioButtonMenuItem
      (new DrawModeAction(WordMap.get(WordMap.AREA),frame.getModel(),
      	      	      	  WorldMapModel.AREA));
    JMenuItem dot=new JRadioButtonMenuItem
      (new DrawModeAction(WordMap.get(WordMap.DOT),frame.getModel(),
      	      	      	  WorldMapModel.DOT));
    ButtonGroup bg=new ButtonGroup();
    bg.add(area);
    bg.add(dot);
    viewMenu.add(area,false,"A");
    viewMenu.add(dot,true,"D");

    viewMenu.addSeparator();
    viewMenu.add(new JCheckBoxMenuItem
      (new OceanLockAction(frame)),true,"O");

    return viewMenu;
  }

//--------------------------------------------------------------------//
/**
 * Help j[쐬
 * @param frame n}\t[
 * @return Helpj[
 */
  private JMenu helpMenu(WorldMapFrame frame){
    AcceleratorMenu helpMenu=
      new AcceleratorMenu(CommandMap.get(CommandMap.HELP));

    String version[]={WordMap.get(WordMap.VERSION1),
      	      	      WordMap.get(WordMap.VERSION2),
      	      	      WordMap.get(WordMap.VERSION3),
      	      	      WordMap.get(WordMap.VERSION4)};
    helpMenu.add(new VersionInfoAction
      (frame,version,IconManager.get(WorldMapFrame.ICON_NAME)),"V");
    return helpMenu;
  }
}
