package worldmap;
import java.awt.Color;
import java.awt.geom.Point2D;
import java.lang.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

//--------------------------------------------------------------------//
/**
 * Q}bvf[^f
 */
public class WorldMapModel{

/** C (bN) \ */
  public static final int OCEAN=0;

/** ̈`惂[h\ */
  public static final int AREA=1;

/** _`惂[h\ */
  public static final int DOT=0;

/** `g嗦̍ől */
  public static final int SCALE_MAX=4;

/** f[^̍s̐ */
  private int row;

/** f[^̗̐ */
  private int column;

/** n}f[^i[z */
  private int point[];

/** _ʒu\ <code>Point2D</code> */
  private Point2D theta;

/** `惂[h */
  private int swdraw;

/** `g嗦 */
  public int scale;

/** CύXbN */
  public boolean oceanLock;

/** ̈|C^ */
  protected int pointer;

/** ̈\Fi[z */
  protected Color color[];

/**
 * Q}bvf[^f\z
 */
  public WorldMapModel(){
    init();
  }

//--------------------------------------------------------------------//
/**
 * f[^
 */
  public void init(){
    theta=new Point2D.Double();
    column=720;
    row=360;
    point=new int[column*row];
    Arrays.fill(point,0);
    color=new Color[1];
    color[0]=Color.BLUE;
    swdraw=DOT;
    scale=1;
    oceanLock=true;
    pointer=-1;
  }

//--------------------------------------------------------------------//
/**
 * _ʒuԂ
 * @return _ʒu\ <code>Point2D</code>
 */
  public Point2D getLocation(){
    return theta;
  }

//--------------------------------------------------------------------//
/**
 * _ʒuύX
 * @param thetaX _ox
 * @param thetaY _ܓx
 */
  public void setLocation(double thetaX,double thetaY){
    theta.setLocation(thetaX,thetaY);
  }

//--------------------------------------------------------------------//
/**
 * f[^̍s̐Ԃ
 * @return f[^̍s̐
 */
  public int getRow(){
    return row;
  }

//--------------------------------------------------------------------//
/**
 * f[^̗̐Ԃ
 * @return f[^̗̐
 */
  public int getColumn(){
    return column;
  }

//--------------------------------------------------------------------//
/**
 * n}f[^̒lԂ
 * @param index n}f[^̃CfbNX
 * @return w肳ꂽʒu̒n}f[^
 */
  public int getMapPoint(int index){
    return point[index];
  }

//--------------------------------------------------------------------//
/**
 * n}f[^Ԃ
 * @return n}f[^i[z
 */
  public int[] getMapPoints(){
    int pt[]=new int[point.length];
    System.arraycopy(point,0,pt,0,point.length);
    return pt;
  }

//--------------------------------------------------------------------//
/**
 * f[^̍sE̐ݒ肷
 * @param row f[^̍s̐
 * @param column f[^̗̐
 */
  public void setMap(int row,int column){
    int old[]=point;
    point=new int[column*row];
    Arrays.fill(point,0);
    int minColumn=Math.min(column,this.column);
    int minRow=Math.min(row,this.row);
    for(int i=0;i<minRow;i++){
      for(int j=0;j<minColumn;j++){
      	point[column*i+j]=old[this.column*i+j];
      }
    }
    this.row=row;
    this.column=column;
  }

//--------------------------------------------------------------------//
/**
 * n}ݒ肷
 * @param row f[^̍s̐
 * @param column f[^̗̐
 * @param point n}f[^i[z
 */
  public void setMap(int row,int column,int point[]){
    this.row=row;
    this.column=column;
    this.point=new int[row*column];
    System.arraycopy(point,0,this.point,0,row*column);
  }

//--------------------------------------------------------------------//
/**
 * \FԂ
 * @param index n}f[^̃CfbNX
 * @return w肳ꂽʒu̕\F
 */
  public Color getColor(int index){
    return color[point[index]];
  }

//--------------------------------------------------------------------//
/**
 * ̈\Fݒ肷
 * @param region ̈i[z
 */
  public void setColors(Region region[]){
    color=new Color[region.length];
    for(int i=0;i<region.length;i++){
      color[i]=region[i].getColor();
    }
  }

//--------------------------------------------------------------------//
/**
 * ̈\Fݒ肷
 * @param list ̈i[Xg
 */
  public void setColors(List list){
    int size=list.size();
    color=new Color[size];
    for(int i=0;i<size;i++){
      color[i]=((Region)list.get(i)).getColor();
    }
  }

//--------------------------------------------------------------------//
/**
 * CύXbNݒ肷
 * @param oceanLock CύXbN̐ݒl
 */
  public void setOceanLock(boolean oceanLock){
    this.oceanLock=oceanLock;
  }

//--------------------------------------------------------------------//
/**
 * |C^ݒ肷
 * @param pointer ̈|C^
 */
  public void setPointer(int pointer){
    this.pointer=pointer;
  }

//--------------------------------------------------------------------//
/**
 * ̈Đݒ肷
 * @param pointer V̈ԍi[z
 */
  public void resetRegion(int pointer[]){
    for(int i=0;i<point.length;i++){
      int newPoint=pointer[point[i]];
      if(newPoint<0) point[i]=1;
      else           point[i]=newPoint;
    }
  }

//--------------------------------------------------------------------//
/**
 * `惂[hݒ肷
 * @param swdraw `惂[h\
 */
  public void setDrawMode(int swdraw){
    this.swdraw=swdraw;
  }

//--------------------------------------------------------------------//
/**
 * ̈g嗦Ԃ
 * @return ̈g嗦
 */
  public int getScale(){
    return scale;
  }

//--------------------------------------------------------------------//
/**
 * ̈g嗦ύX
 * @param scale ̈g嗦
 */
  public void setScale(int scale){
    this.scale=scale;
  }

//--------------------------------------------------------------------//
/**
 * n}ύX
 * @param mx ύXʒu <i>x</i> W
 * @param my ύXʒu <i>y</i> W
 */
  public void changeMap(int mx,int my){
    if(pointer<0) return;
    int x=Math.max(Math.min(mx/scale,column-1),0);
    int y=Math.max(Math.min(my/scale,row-1),0);
    switch(swdraw){
      case AREA:
      	int x1=Math.max(x-1,0);
      	int x2=Math.min(x+2,column);
      	int y1=Math.max(y-1,0);
      	int y2=Math.min(y+2,row);
      	for(int j=y1;j<y2;j++){
      	  for(int i=x1;i<x2;i++){
    	    int ii=column*j+i;
      	    if(!oceanLock || (point[ii]!=OCEAN)){
      	      point[ii]=pointer;
      	    }
      	  }
      	}
      	break;
      case DOT:
      	int ii=column*y+x;
      	if(!oceanLock || (point[ii]!=OCEAN)){
      	  point[ii]=pointer;
      	}
      	break;
    }
  }
}
