package worldmap;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.lang.*;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import gui.BasicPanel;
import gui.transfer.CopyAction;
import laf.DrawParameter;

//--------------------------------------------------------------------//
/**
 * n}\pl
 */
public class WorldMapPanel extends BasicPanel{

/** Q}bvf[^f */
  private WorldMapModel model;

/**
 * n}\pl\z
 * @param model Q}bvf[^f
 */
  public WorldMapPanel(WorldMapModel model){
    super();
    this.model=model;
  }

//--------------------------------------------------------------------//
/**
 * Q}bvf[^fԂ
 * @return Q}bvf[^f
 */
  public WorldMapModel getModel(){
    return model;
  }

//--------------------------------------------------------------------//
/**
 * }EX{^̏s
 * @param e }EXANVƂCxg
 */
  public void mousePressed(MouseEvent e){
    model.changeMap(e.getX(),e.getY());
    super.mousePressed(e);
  }

//--------------------------------------------------------------------//
/**
 * }EXhbȌs
 * @param e }EXANVƂCxg
 */
  public void mouseDragged(MouseEvent e){
    model.changeMap(e.getX(),e.getY());
    super.mouseDragged(e);
  }

//--------------------------------------------------------------------//
/**
 * \TCYݒ肷
 * @param d \TCY
 */
  public void setViewSize(Dimension d){
    int width=Math.max(d.width,model.getColumn()*model.getScale());
    int height=Math.max(d.height,model.getRow()*model.getScale());
    d.setSize(width,height);
    super.setViewSize(d);
  }

//--------------------------------------------------------------------//
/**
 * g傷
 */
  public void zoomin(){
    if(model.getScale()<WorldMapModel.SCALE_MAX){
      model.setScale(model.getScale()+1);
    }
  }

//--------------------------------------------------------------------//
/**
 * k
 */
  public void zoomout(){
    if(model.getScale()>1){
      model.setScale(model.getScale()-1);
    }
  }

//--------------------------------------------------------------------//
/**
 * |bvAbvj[Ԃ
 * @return |bvAbvj[
 */
  public JPopupMenu getPopupMenu(){
    JPopupMenu popupMenu=new JPopupMenu();
    popupMenu.add(new JMenuItem(new CopyAction(this)));
    return popupMenu;
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  public void paintModel(Graphics2D g){
    int row=model.getRow();
    int column=model.getColumn();
    int scale=model.getScale();
    int ii=0;
    for(int i=0;i<row;i++){
      int jj=0;
      int y0=scale*i;
      while(jj<column){
      	int j0=jj;
      	int x0=scale*j0;
      	while((jj<column-1)
      	   && (model.getMapPoint(ii)==model.getMapPoint(ii+1))){
      	  ii++;
      	  jj++;
      	}
      	g.setColor(model.getColor(ii));
      	g.fillRect(x0,y0,scale*(jj-j0+1),scale);
      	ii++;
      	jj++;
      }
    }

  }
}
