package worldmap.io;
import java.awt.Color;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.*;
import javax.imageio.ImageIO;
import data.IntegerMap;
import fileio.TextDataIO;
import worldmap.Region;
import worldmap.RegionList;
import worldmap.WorldMapModel;

//--------------------------------------------------------------------//
/**
 * Q}bvǂݍ݃NX
 */
public class WorldMapIO extends TextDataIO{

/** }bv̈惊Xg */
  protected RegionList list;

/** Q}bvf[^f */
  protected WorldMapModel map;

/**
 * Q}bvǂݍ݃IuWFNg\z
 * @param list }bv̈惊Xg
 * @param map Q}bvf[^f
 */
  public WorldMapIO(RegionList list,WorldMapModel map){
    this.list=list;
    this.map=map;
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param name f[^
 * @param br ̓[_[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void readData(String name,BufferedReader br) throws Exception{
    int row=360;
    int column=720;
    int point[]=new int[column*row];
    int ii=0;
    int regionNumber=0;
    int regionIndex[]=null;
    Region region[]=null;
    IntegerMap regionMap=new IntegerMap();

    while(true){
      String line=br.readLine();
      if(line==null) break;
      String ss[]=split(line);
      if(ss.length>=1){
      	String keyWord=ss[0].toLowerCase();
      	if(ss.length>=3){
      	  if(keyWord.equals("init")){
      	    double theta1=Double.parseDouble(ss[1]);
      	    double theta2=Double.parseDouble(ss[2]);
      	    map.setLocation(theta1,theta2);
      	  }
      	  else if(keyWord.equals("region")){
      	    column=Integer.parseInt(ss[1]);
      	    row=Integer.parseInt(ss[2]);
      	    point=new int[column*row];
      	  }
      	  else{
      	    regionIndex[regionNumber]=Integer.parseInt(keyWord);
      	    int rgb=Integer.parseInt(ss[1],16);
      	    region[regionNumber]=new Region(ss[2],new Color(rgb));
      	    regionMap.putInt(rgb,regionNumber);
      	    regionNumber++;
      	  }
      	}
     	else if(ss.length>=2){
      	  if(keyWord.equals("image")){
      	    int size=readImageData(ss[1],point);
      	    for(int i=0;i<size;i++){
      	      point[i]=regionMap.getInt(0xFFFFFF&point[i]);
      	    }
      	  }
      	  else{
      	    int number=Integer.parseInt(keyWord);
      	    int pt=Integer.parseInt(ss[1]);
      	    for(int i=0;i<number;i++){
      	      point[ii]=pt;
      	      ii++;
      	    }
      	  }
      	}
      	else if(ss.length==1){
      	  int size=Integer.parseInt(keyWord);
      	  regionIndex=new int[size];
      	  region=new Region[size];
      	}
      }
    }
    list.setRegions(region);
    map.setMap(row,column,point);
  }


//--------------------------------------------------------------------//
/**
 * C[Wf[^ǂݍ
 * @param fileName C[Wt@C
 * @param rgb RGB sNZ̔z
 * @return C[Wf[^̑傫
 * @throws IOException 炩̗RŃt@Cǂ߂ȂƂ
 */
  protected int readImageData(String fileName,int rgb[])
    throws IOException{

    BufferedImage image=ImageIO.read(new File(fileName));
    int width=image.getWidth();
    int height=image.getHeight();
    image.getRGB(0,0,width,height,rgb,0,width);
    return width*height;
  }

//--------------------------------------------------------------------//
/**
 * f[^
 * @param pw o̓C^[
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public void writeData(PrintWriter pw) throws Exception{
    Point2D theta=map.getLocation();
    pw.print("init\t");
    pw.print(theta.getX());
    pw.print('\t');
    pw.println(theta.getY());
    pw.print("region\t");
    pw.print(map.getColumn());
    pw.print('\t');
    pw.println(map.getRow());
    int rsize=list.getRegionCount();
    pw.println(rsize);
    for(int i=0;i<rsize;i++){
      pw.print(i);
      pw.print('\t');
      pw.println(String.valueOf(list.getRegion(i)));
    }
    int number=1;
    int point[]=map.getMapPoints();
    for(int i=1;i<point.length;i++){
      if(point[i-1]==point[i]){
      	number++;
      }
      else{
      	pw.print(number);
      	pw.print('\t');
      	pw.println(point[i-1]);
      	number=1;
      }
    }
    pw.print(number);
    pw.print('\t');
    pw.println(point[point.length-1]);
  }
}
